{
              Program Name : ASCIIDEF
              Package Name : LB
              Purpose      : Definitions of ASCII constants
              Institution  : Conroy & Conroy Co.
              Date Written : 23-Apr-1995
              Written By   : Alan Conroy
              Version      : 1.0

              Copyright (c) 1995-2004 by Alan Conroy.  Released to the public domain.

	      TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *            F I L E   D E S C R I P T I O N S          *
        *                                                       *
        *********************************************************

}

unit ASCIIDef ;

interface

const NUL = #0 ; { Null }
      SOH = #1 ; { Start Of Heading }
      STX = #2 ; { Start Text }
      ETX = #3 ; { End Text }
      EOT = #4 ; { End Of Transmission }
      ENQ = #5 ; { Enquiry }
      ACK = #6 ; { Acknowledge }
      BEL = #7 ; { Bell }
      BS = #8 ; { Backspace }
      HT = #9 ; { Horizontal Tab }
      LF = #10 ; { Line Feed }
      VT = #11 ; { Vertical Tab }
      FF = #12 ; { Form Feed }
      CR = #13 ; { Carriage return }
      SO = #14 ; { Shift Out }
      SI = #15 ; { Shift In }
      DLE = #16 ; { Data Link Escape }
      DC1 = #17 ; { Direct Control 1 }
      DC2 = #18 ; { Direct Control 2 }
      DC3 = #19 ; { Direct Control 3 }
      DC4 = #20 ; { Direct Control 4 }
      NAK = #21 ; { Negative Acknowledge }
      SYN = #22 ; { Synchronous idle }
      ETB = #23 ; { End Tranmission Block }
      CAN = #24 ; { Cancel }
      EM = #25 ; { End of Medium }
      SUB = #26 ; { Substitute }
      ESC = #27 ; { Escape }
      Escape = #27 ; { Ditto }
      FS = #28 ; { Form separator }
      GS = #29 ; { Group separator }
      RS = #30 ; { Record separator }
      US = #31 ; { Unit separator }
      Space = #32 ;
      SP = #32 ; { Space }
      DEL = #127 ; { Delete }

      { DEC supplemental codes... }
      IND = #132 ;
      NEL = #133 ;
      SSA = #134 ;
      ESA = #135 ;
      HTS = #136 ;
      HTJ = #137 ;
      VTS = #138 ;
      PLD = #139 ;
      PLU = #140 ;
      RI = #141 ;
      SS2 = #142 ;
      SS3 = #143 ;
      DCS = #144 ;
      PU1 = #145 ;
      PU2 = #146 ;
      STS = #147 ;
      CCH = #148 ;
      MW = #149 ;
      SPA = #150 ;
      EPA = #151 ;
      CSI = #155 ;
      ST = #156 ;
      OSC = #157 ;
      PM = #158 ;
      APC = #159 ;
      NBSP = #160 ;
      
      { Used by SMU... }
      EBS = #254 ; { Extended backspace }

      { Combination codes... }
      CRLF = #13#10 ; { CR and LF }

{ Return ASCII code for specified value }
function ASCII_Codes( X : integer ) : string ;

implementation

const _ASCII_Codes : array[ 0..31 ] of string[ 3 ] = (
                                                        'NUL',
                                                        'SOH',
                                                        'STX',
                                                        'ETX',
                                                        'EOT',
                                                        'ENQ',
                                                        'ACK',
                                                        'BEL',
                                                        'BS',
                                                        'HT',
                                                        'LF',
                                                        'VT',
                                                        'FF',
                                                        'CR',
                                                        'SO',
                                                        'SI',
                                                        'DLE',
                                                        'DC1',
                                                        'DC2',
                                                        'DC3',
                                                        'DC4',
                                                        'NAK',
                                                        'SYN',
                                                        'ETB',
                                                        'CAN',
                                                        'EM',
                                                        'SUB',
                                                        'ESC',
                                                        'FS',
                                                        'GS',
                                                        'RS',
                                                        'US' ) ;

{ Return ASCII code for specified value }
function ASCII_Codes( X : integer ) : string ;

begin
    X := X and 255 ;
    if( X = 127 ) then
    begin
        ASCII_Codes := 'DEL' ;
        exit ;
    end ;
    if( X < 32 ) then
    begin
        ASCII_Codes := _ASCII_Codes[ X ] ;
        exit ;
    end ;
    ASCII_Codes := chr( X ) ;
end ;


end.
