{
        Program Name : Debug_Form
        Package Name : LB
        Purpose      : Outline interface for debug interface objects
        Institution  : Conroy & Conroy Co.
        Date Written : 20-Feb-1999
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This form is the UI to debug interface objects.
}

unit debug_Dialog ;

interface

uses // Borland...
     Windows,
     Messages,
     SysUtils,
     Classes,
     Graphics,
     Controls,
     Forms, // TForm
     Dialogs,
     ComCtrls ; // TTreeView

type TDebug_Form = class( TForm )
                                Tree_View : TTreeView ;

                                procedure FormCreate( Sender : TObject ) ;

                            protected // Callbacks...
                                procedure CB_Click( Sender : TObject ) ;
                                procedure CB_Collapse( Sender : TObject ; Node : TTreeNode ) ;
                                procedure CB_Expand( Sender : TObject ; Node : TTreeNode ) ;
                        end ;

var Debug_Form : TDebug_Form = nil ;

procedure Begin_Debugger ;

implementation

{$R *.DFM}

uses // C&C...
     _App, // Application_Manager
     _DebugIn, // PDebug_Interface
     DebugInt, // TText_Debugger
     O_S ; // OS

procedure Begin_Debugger ;

begin
    if( Debug_Form = nil ) then
    begin
        Debug_Form := TDebug_Form.Create( Application ) ;
    end ;
    Debug_Form.ShowModal ;
end ;

// TMain_Debug_Form methods...

procedure TDebug_Form.FormCreate( Sender : TObject ) ;

var Count : integer ;
    I : PSDebug_Interface ;
    This_Node : TTreeNode ;

begin
    // Initialize the outline...
    Count := 0 ;
    I := Application_Manager^.Application_Debugger ;
    if( I <> nil ) then
    begin
        inc( Count ) ;
        This_Node := Tree_View.Items.AddChildObject( nil, 'Application = ' +
            Application_Manager.Name + ' ' + Application_Manager.Version, I ) ;
        if( I.Count > 0 ) then
        begin
            Tree_View.Items.AddChildObject( This_Node, '', nil ) ; // Place holder
        end ;
    end ;
    I := OS.Debugger ;
    if( I <> nil ) then
    begin
        inc( Count ) ;
        This_Node := Tree_View.Items.AddChildObject( nil, 'Operating System = ' +
            OS.Name + ' ' + OS.Version, I ) ;
        if( I.Count > 0 ) then
        begin
            Tree_View.Items.AddChildObject( This_Node, '', nil ) ; // Place holder
        end ;
    end ;
    if( Count = 0 ) then
    begin
        Tree_View.Items.AddChild( nil, 'There is no debugging information available' ) ;
    end ;

    // Set up callbacks...
    Tree_View.OnClick := CB_Click ;
    Tree_View.OnCollapsed := CB_Collapse ;
    Tree_View.OnExpanded := CB_Expand ;
end ;


// Callbacks...

procedure TDebug_Form.CB_Click( Sender : TObject ) ;

var I : PSDebug_Interface ;

begin
    I := PSDebug_Interface( Tree_View.Selected.Data ) ;
    I.Activate ;
end ;


procedure TDebug_Form.CB_Collapse( Sender : TObject ; Node : TTreeNode ) ;

var I : PSDebug_Interface ;
    This_Node : TTreeNode ;

begin
    This_Node := Node.GetFirstChild ;
    while( This_Node <> nil ) do
    begin
        I := PSDebug_Interface( This_Node.Data ) ;
        I.Free ;
        This_Node := This_Node.GetNext ;
    end ;
    Node.DeleteChildren ;
    I := PSDebug_Interface( Node.Data ) ;
    if( I.Count > 0 ) then
    begin
        Tree_View.Items.AddChildObject( Node, '', nil ) ;
    end ;
end ;


procedure TDebug_Form.CB_Expand( Sender : TObject ; Node : TTreeNode ) ;

var I, I1 : PSDebug_Interface ;
    Loop : integer ;
    S : string ;
    This_Node : TTreeNode ;

begin
    Cursor := crHourGlass ;
    I := PSDebug_Interface( Node.Data ) ;
    if( Node.GetFirstChild <> nil ) then
    begin
        Tree_View.Items.Delete( Node.GetFirstChild ) ; // Delete placeholder
    end ;
    for Loop := 0 to I.Count - 1 do
    begin
        I1 := I.Child( Loop ) ;
        S := I1^.Get_Title ;
        S := copy( S, 1, 255 ) ; // VCL node names are limited to 255 bytes (or else abend)
        This_Node := Tree_View.Items.AddChildObject( Node, S, I1 ) ;
        if( I1^.Count > 0 ) then
        begin
            Tree_View.Items.AddChildObject( This_Node, '', nil ) ; // Place holder
        end ;
    end ;
    Cursor := crDefault	;
end ;



end.
