.RADIX  10
.8086

;              Program Name : INSTR
;              Package Name : LB
;              Purpose      : INSTR function
;              Institution  : Conroy & Conroy Company
;              Date Written : 11-Nov-86
;              Written By   : Alan Conroy
;              Version      : 9.2-10
;
;        *********************************************************
;        *                                                       *
;        *        M O D I F I C A T I O N   H I S T O R Y        *
;        *                                                       *
;        *     DATE      BY             REASON                   *
;        *                                                       *
;        *********************************************************
;
;        *********************************************************
;        *                                                       *
;        *           P R O G R A M   P U R P O S E               *
;        *                                                       *
;        *********************************************************
;
;   This routine searches for a character in the WorkBuff area.  The character
; to search for is in AL, the position to begin the search at is in CX.  The
; result is returned in CL.  CL is zero (0) if the character was not found.
; CH will always be zero (0).
;

INSTR:  PUSH AX ; Save registers
        PUSH BX
        PUSH DX
        PUSH SI
        PUSHF
        MOV  BX, OFFSET WorkBLen
        MOV  DL, [BX] ; Get length of string
        MOV  DH, 0
        MOV  BX, OFFSET WorkBuff ; Point to beginning of buffer
        MOV  CH, 0
        MOV  SI, CX ; Offset into work buffer
        CMP  CL, 0  ; Is beginning at character zero (0)?
        JNE  Ins0   ; Nope
        MOV  SI, 1  ; Yes, so convert to character 1

Ins0:   ; Beginning of loop
        CMP  DX, SI ; Are we past end of string yet?
        JGE  Ins1   ; Nope
        MOV  CL, 0  ; Character not found
        JMP  Insend ; End

Ins1:   MOV  AH, [BX+SI] ; Get next character
        INC  SI     ; Increment offset
        CMP  AL, AH ; A match?
        JNE  Ins0   ; No
        MOV  CX, SI ; Get position
        DEC  CX     ; Return it in CL

Insend: POPF    ; Restore registers
        POP  SI
        POP  DX
        POP  BX
        POP  AX
        RET     ; All done now
