/*
	      Program Name : TEU
	      Package Name : LB
	      Purpose      : Text Editing Utility
	      Institution  : Conroy & Conroy
	      Original Vers: 22-Mar-89
	      Date Written : 21-Jul-1990
	      Written By   : Alan Conroy
	      Version      : 2.0

              Copyright (C) 1989-1990 by Alan Conroy.  Released to the public domain.

	      TO THE GLORY OF GOD THROUGH JESUS CHRIST

	*********************************************************
	*                                                       *
	*        M O D I F I C A T I O N   H I S T O R Y        *
	*                                                       *
	*     DATE      BY             REASON                   *
	*                                                       *
	*********************************************************

	*********************************************************
	*                                                       *
	*           P R O G R A M   P U R P O S E               *
	*                                                       *
	*********************************************************

	  Conceptual equivalent to VAX TPU.
*/

#ifndef _TEU_H
#define _TEU_H
struct Anchor_Type
{
    long int Line ;
    short int Column, P_Column ;
} ;


struct Line_Record
{
    struct Line_Record *Last_Line, *Next_Line ;
    char Text[ 256 ] ;
} ;
#endif

static void Adjust() ; /* Adjust cursor position based on tabs, EOL, etc. */
static void Cursor_Up() ;
static void Cursor_Down() ; /* Move cursor down one line */
static void Cursor_Left() ; /* Move cursor left one character */
static void Cursor_Right() ; /* Move cursor one character to the right */
static void Delete_Char( int Explicit ) ;
static void Deletecrlf( int Explicit ) ;
static void Do_Change() ;
static void Do_Help() ; /* Display help on screen */
static void Do_Read() ; /* Get next input */
static void Do_Search() ; /* Search for text */
static void Do_Update() ; /* Update memory with edited line - if needed */
static void Do_Write( char *Command, struct Line_Record *File_Root ) ;
static void End_Edit() ; /* Terminate TEU session */
static void Execute_Command( char *Passed_Command ) ; /* Execute a TEU command */
static void Flag_Changes() ; /* Flag any changes to line */
static void Format( char *X ) ;
static void Handle_Selection( short int Cursor_Row, short int Physical_Column,
    char *Physical_Text ) ; /* Reverse video for selected text */
static char *In_Key() ; /* Get next keystroke */
static void Include_File( char *Passed_Command, long int *Last_Line,
    struct Line_Record **File_Root, struct Line_Record **File_Last ) ;
static void Insert_Chars( char *Character ) ; /* Character(s) insertion */
static void New_Line() ; /* Insert a new line/create two lines from one */
static void Redraw() ; /* Draw/redraw screen */
static void Show_Error( char *X ) ;
static void Teu_Advance() ; /* Advance to beginning of next line */
static void Teu_Bottom() ;
static void Teu_Change_Case() ;
static void Teu_Cut() ; /* Cut selected text and put it into the paste buffer */
static void Teu_Delete_Line() ;
static void Teu_Delete_Word() ; /* Delete current word */
static void Teu_Eol() ; /* Move to end of current line */
static void Teu_Half_Page() ; /* Advance one-half page (11 lines) */
static void Teu_Insert_Line() ; /* Insert blank line */
static void Teu_Move_Word() ; /* Move to beginning of next word */
static void Teu_Page() ; /* Advance one page (22 lines) */
static void Teu_Paste() ; /* Insert text from paste buffer */
static void Teu_Search() ; /* Search for text */
static void Teu_Select() ; /* Begin selection */
static void Teu_Setup() ;
static void Teu_Special_Insert() ; /* Insert a character by ASCII value */
static void Teu_Top() ; /* Go to top of buffer */
static void Teu_Undelete_Line() ; /* Undelete previously deleted line */
static void Teu_Unselect() ; /* Unselect text */
void Teu_Teu( char *Passed_Command ) ; /* Main routine */
static void Update_Journal() ;

