unit TypeDefs ;

{
        Unit Name    : TypeDefs
        Package Name : Subroutine Library - Layer 0
        Purpose      : General Pascal types
        Institution  : Conroy & Conroy Co.
        Date Written : 2000
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (c) 2000 by Alan Conroy.  Released to the Public Domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        * 19-Nov-2002    EAC         Moved int64 and smallint here  *
        *                            from Compatib.                 *
        * 21-Nov-2002    EAC         Added tChar_Array and          *
        *                            PChar_Array.                   *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This module defines simple generic Pascal types.
}

interface

{$I EDEFINES.INC}

{$IFNDEF WINDOWS}
  {$IFDEF DELPHI_32BIT}
uses Windows, { TRect }
     _Types ;
  {$ELSE}
uses DOS, _Types ;
  {$ENDIF}
{$ENDIF}


{ Common types... }
type TComparison = ( LessThan, EqualTo, GreaterThan, LessThanOrEqual, GreaterThanorEqual, NotEqualTo ) ;
     TTri_State = ( TS_False, TS_True, TS_Dont_Care ) ;

{$IFDEF DELPHI_32BIT}
type { Events... }
     TClick_Notify_Event = procedure( Sender : TObject ; Point : TSmallPoint ) of object ;
     TCommand_Event = procedure( Sender : TObject ; Command : integer ) of object ;
     TPaint_Notify_Event = procedure( Sender : TObject ; Beginning : Boolean ) of object ;
     TRequest_Data_Event = procedure( Sender : TObject ; Top : Boolean ) of object ;
     TNotify_Blink_Event = procedure( Rect : TRect ) of object ;

     TArrayOfInteger = array of integer; { A delphi dynamic array }
{$ENDIF}

{ Various constants... }
{$IFDEF DELPHI_32BIT}
const Max_Memory = $3FFFFFFF ;
const Max_String_Length = Max_Memory ;
const Zero64 : int64 = 0 ;

type TRecord_Size = integer ;
{$ELSE}
const Max_Memory = 65528 ;
const Max_String_Length = 255 ;
const Zero64 : int64 = 0.0 ;

type TRecord_Size = word ;
{$ENDIF}

type pByte = ^byte ;
     tByte_Array = array[ 0..Max_Memory div sizeof( byte ) - 1 ] of byte ;
     pByte_Array = ^tByte_Array ;

     pShortInt = ^ShortInt ;
     tShortInt_Array = array[ 0..Max_Memory div sizeOf( ShortInt ) - 1 ] of ShortInt ;
     pShortInt_Array = ^TShortInt_Array ;

     pWord = ^Word ;
     tWord_Array = array[ 0..Max_Memory div sizeof( word ) - 1 ] of word ;
     pWord_Array = ^tWord_Array ;

     pInteger = ^Integer ;
     tInteger_Array = array[ 0..Max_Memory div sizeof( Integer ) - 1 ] of integer ;
     pInteger_Array = ^tInteger_Array ;

     pLongint = ^Longint ;
     tLongint_Array = array[ 0..Max_Memory div sizeof( longint ) - 1 ] of longint ;
     pLongint_Array = ^tLongint_Array ;

     pReal = ^Real ;
     tReal_Array = array[ 0..Max_Memory div sizeof( Real ) - 1 ] of Real ;
     pReal_Array = ^TReal_Array ;

     pSingle = ^Single ;
     tSingle_Array = array[ 0..Max_Memory div sizeof( Single ) - 1 ] of Single ;
     pSingle_Array = ^TSingle_Array ;

     pDouble = ^Double ;
     tDouble_Array = array[ 0..Max_Memory div sizeof( Double ) - 1 ] of Double ;
     pDouble_Array = ^TDouble_Array ;

     tExtended_Array = array[ 0..Max_Memory div sizeof( Extended ) - 1 ] of Extended ;
     pExtended_Array = ^TExtended_Array ;

     pComp = ^Comp ;
     tComp_Array = array[ 0..Max_Memory div sizeof( Comp ) - 1 ] of Comp ;
     pComp_Array = ^tComp_Array ;

     pPointer = ^Pointer ;
     tPointer_Array = array[ 0..Max_Memory div sizeof( pointer ) - 1 ] of pointer ;
     pPointer_Array = ^tPointer_Array ;

     tPChar_Array = array[ 0..Max_Memory div sizeof( PChar ) - 1 ] of PChar ;
     pPChar_Array = ^tPChar_Array ;

     tChar_Array = array[ 0..Max_Memory div sizeof( Char ) - 1 ] of Char ;
     pChar_Array = ^tChar_Array ;

     pFile = ^File ;
     tFile_Array = array[ 0..Max_Memory div sizeof( File ) - 1 ] of File ;
     pFile_Array = ^tFile_Array ;

     pText = ^Text ;
     tText_Array = array[ 0..Max_Memory div sizeof( Text ) - 1 ] of Text ;
     pText_Array = ^tText_Array ;

{$IFDEF DELPHI_32BIT}
     pString = string ;
{$ELSE}
     pExtended = ^Extended ;
     pString = ^string ;
     Real48 = Real ;
     AnsiChar = Char ;
     TextFile = Text ;
     pByteArray = pByte_Array ;
     pWordArray = pWord_Array ;
{$ENDIF}
     tString_Array = array[ 0..Max_Memory div sizeof( pString ) - 1 ] of pString ;
     pString_Array = ^tString_Array ;

{ Compatibility types }
{$IFDEF DELPHI_32BIT}
     pLongword = ^Longword ;
     tLongword_Array = array[ 0..Max_Memory div sizeof( Longword ) - 1 ] of Longword ;
     pLongword_Array = ^tLongword_Array ;

     pCardinal = ^Cardinal ;
     tCardinal_Array = array[ 0..Max_Memory div sizeof( Cardinal ) - 1 ] of Cardinal ;
     pCardinal_Array = ^tCardinal_Array ;

     pInt64 = ^Int64 ;
     tInt64_Array = array[ 0..Max_Memory div sizeof( Int64 ) - 1 ] of Int64 ;
     pInt64_Array = ^tInt64_Array ;

     tCurrency_Array = array[ 0..Max_Memory div sizeof( Currency ) - 1 ] of Currency ;
     pCurrency_Array = ^tCurrency_Array ;

     tANSIString_Array = array[ 0..Max_Memory div sizeof( ANSIString ) - 1 ] of ANSIString ;
     pANSIString_Array = ^tANSIString_Array ;

     pWideChar = ^WideChar ;
     tWideChar_Array = array[ 0..Max_Memory div sizeof( WideChar ) - 1 ] of WideChar ;
     pWideChar_Array = ^tWideChar_Array ;

     tWideString_Array = array[ 0..Max_Memory div sizeof( WideString ) - 1 ] of WideString ;
     pWideString_Array = ^tWideString_Array ;

     tVariant_Array = array[ 0..Max_Memory div sizeof( Variant ) - 1 ] of Variant ;
     pVariant_Array = ^tVariant_Array ;

     tOLEVariant_Array = array[ 0..Max_Memory div sizeof( OLEVariant ) - 1 ] of OLEVariant ;
     pOLEVariant_Array = ^tOLEVariant_Array ;
{$ENDIF}

     pSmall_String = ^Small_String ;
     tSmall_String_Array = array[ 0..Max_Memory div sizeof( pSmall_String ) - 1 ] of pSmall_String ;
     pSmall_String_Array = ^tSmall_String_Array ;

     pBoolean = ^Boolean ;
     tBoolean_Array = array[ 0..Max_Memory div sizeOf( boolean ) - 1 ] of boolean ;
     pBoolean_Array = ^TBoolean_Array ;

     pByteBool = ^ByteBool ;
     tByteBool_Array = array[ 0..Max_Memory div sizeOf( ByteBool ) - 1 ] of ByteBool ;
     pByteBool_Array = ^TByteBool_Array ;

     pWordBool = ^WordBool ;
     tWordBool_Array = array[ 0..Max_Memory div sizeOf( WordBool ) - 1 ] of WordBool ;
     pWordBool_Array = ^TWordBool_Array ;

     pLongBool = ^LongBool ;
     tLongBool_Array = array[ 0..Max_Memory div sizeOf( LongBool ) - 1 ] of LongBool ;
     pLongBool_Array = ^TLongBool_Array ;

     pReal48 = ^Real48 ;
     tReal48_Array = array[ 0..Max_Memory div sizeof( Real48 ) - 1 ] of Real48 ;
     pReal48_Array = ^tReal48_Array ;


implementation

end.
