/*
        Program Name : UStrings
        Package Name : LB
        Purpose      : String utility routines.
        Institution  : Conroy & Conroy Co.
        Date Written : 06-Oct-1994
        Written By   : Alan Conroy
        Version      : 1
        Revision     : 0
        Edit         :

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  These functions perform various string operations.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <mem.h>

#include "ustrings.h"

void strpas( char *Result, char *X ) /* Convert C to Pascal */
{

    if( X == NULL )
    {
	Result[ 0 ] = 0 ;
	return ;
    } ;
    Result[ 0 ] = strlen( X ) ;
    strcpy( &Result[ 1 ], X ) ;
    return ;
} ;


char *strc( char *X ) /* Convert Pascal to C */
{

static char Result[ 256 ] ;

    memcpy( &Result, &X[ 1 ], X[ 0 ] ) ; /* Copy salient portion */
    Result[ X[ 0 ] ] = 0 ; /* Zero terminate string */
    return Result ;
} ;


char *Left( char *S, int X ) /* Copy left portion of string */
{

static char *Buffer ;

    Buffer[ 0 ] = 0 ;
    if( S == NULL ) /* String is null */
    {
	return Buffer ;
    } ;
    if( X < 1 ) /* Negative or zero characters to copy */
    {
	return Buffer ;
    } ;
    Buffer = malloc( X + 1 ) ;
    strncpy( Buffer, S, X ) ; /* Copy */
    Buffer[ X ] = 0 ; /* strncpy doesn't always terminate */
    return Buffer ;
} ;


void FRight( char *Z, char *C, int Position ) /* This function performs a Right function */
{

    if( Position < 1 )
    {
	Position = 1 ;
    } ;
    if( Position > strlen( C ) )
    {
	Z[ 0 ] = 0 ;
    }
    else
    {
	memmove( Z, &C[ Position - 1 ], strlen( C ) - Position + 2 ) ;
    } ;
} ;


char *Right( char *C, int Position ) /* This function performs a RIGHT function */
{

char *A ;
int X ;

    X = strlen( C ) - Position + 1 ;
    if( C == NULL || X < 2 )
    {
	return NULL ;
    } ;
    A = malloc( X ) ;
    FRight( A, C, Position ) ;
    return A ;
} ;


void Add_Commas( char *X ) /* Add commas to number */
{
    if( strlen( X ) < 4 )
    {
	return ;
    } ;
    memmove( &X[ strlen( X ) - 2 ], &X[ strlen( X ) - 3 ], 4 ) ;
    X[ strlen( X ) - 4 ] = ',' ;
} ;

