{$N+}
{
        Program Name : Clock
        Package Name : CEF
        Purpose      : Generic system clock for CEF
        Institution  : 
        Date Written : 28-Apr-2000
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Released to the public domain.

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit implements a generic system clock for CEF, for Borland
        Pascal and FPK.
}

unit Clock ;

interface

uses { CEF... }
     CEF ; { TMaster_Clock }

type TCEF_Generic_Clock = class( TMaster_Clock )
	private { Instance data... }
	    _Time_Index : int64 ;
	    _UI : TUI_Interface ;

	public { Public instance data... }
           _Serial_Number : integer ;

        public { API... }
           procedure Block( Component : TComponent ; Time_Delta : int64 ) ;
               override ;

           procedure Initialize( UI : TUI_Interface ) ; override ;

           function Get_Time_Index : int64 ; override ;

           function Serial_Number : integer ; override ;
     end ;

implementation

{ TCEF_Generic_Clock methods... }

procedure TCEF_Generic_Clock.Block( Component : TComponent ;
    Time_Delta : int64 ) ;

begin
    _Time_Index := _Time_Index + Time_Delta ;
    Component.Wake ;
end ;


procedure TCEF_Generic_Clock.Initialize( UI : TUI_Interface ) ;

begin
    _Time_Index := 0 ;
    _UI := UI ;
end ;


function TCEF_Generic_Clock.Get_Time_Index : int64 ;

begin
    Get_Time_Index := _Time_Index ;
end ;


function TCEF_Generic_Clock.Serial_Number : integer ;

begin
    Result := _Serial_Number ;
end ;


end.

